diff -Ncr linux-2.4.22-ashuariadevel.backup/Documentation/Configure.help linux-2.4.22-ashuariadevel/Documentation/Configure.help
*** linux-2.4.22-ashuariadevel.backup/Documentation/Configure.help	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/Documentation/Configure.help	2004-02-02 14:35:08.000000000 +0900
***************
*** 610,615 ****
--- 610,620 ----
  
    If unsure, say N.
  
+ Large disc support
+ CONFIG_LBD
+   If you have mass-storage devices bigger than 2TB and want to access them,
+   say Y here, and your kernel will use 64-bit sector offsets throughout.
+ 
  ATA/IDE/MFM/RLL support
  CONFIG_IDE
    If you say Y here, your kernel will be able to manage low cost mass
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/Config.in linux-2.4.22-ashuariadevel/drivers/block/Config.in
*** linux-2.4.22-ashuariadevel.backup/drivers/block/Config.in	2003-12-09 11:52:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/Config.in	2004-02-02 14:35:08.000000000 +0900
***************
*** 51,54 ****
--- 51,57 ----
  
  bool 'Per partition statistics in /proc/partitions' CONFIG_BLK_STATS
  
+ if [ "$CONFIG_X86" = "y" -o "$CONFIG_PPC" = "y" ]; then
+    bool 'Support for discs bigger than 2TB?' CONFIG_LBD
+ fi
  endmenu
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/DAC960.c linux-2.4.22-ashuariadevel/drivers/block/DAC960.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/DAC960.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/DAC960.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 5499,5510 ****
  	Controller->GenericDiskInfo.part[MINOR(Inode->i_rdev)].start_sect;
        return (copy_to_user(UserGeometry, &Geometry,
  			   sizeof(DiskGeometry_T)) ? -EFAULT : 0);
!     case BLKGETSIZE:
        /* Get Device Size. */
!       if ((unsigned long *) Argument == NULL) return -EINVAL;
!       return put_user(Controller->GenericDiskInfo.part[MINOR(Inode->i_rdev)]
! 						 .nr_sects,
! 		      (unsigned long *) Argument);
      case BLKGETSIZE64:
        if ((u64 *) Argument == NULL) return -EINVAL;
        return put_user((u64) Controller->GenericDiskInfo
--- 5499,5515 ----
  	Controller->GenericDiskInfo.part[MINOR(Inode->i_rdev)].start_sect;
        return (copy_to_user(UserGeometry, &Geometry,
  			   sizeof(DiskGeometry_T)) ? -EFAULT : 0);
!     case BLKGETSIZE: {
        /* Get Device Size. */
! 	    unsigned long sz;
! 	    if ((unsigned long *) Argument == NULL) return -EINVAL;
! 	    sz = Controller->GenericDiskInfo.part[MINOR(Inode->i_rdev)]
! 		    .nr_sects;
! 	    if ((sector_t)sz !=  Controller->GenericDiskInfo.part[MINOR(Inode->i_rdev)]
! 		.nr_sects)
! 		    return -EFBIG;
! 	    return put_user(sz, (unsigned long *) Argument);
!     }
      case BLKGETSIZE64:
        if ((u64 *) Argument == NULL) return -EINVAL;
        return put_user((u64) Controller->GenericDiskInfo
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/DAC960.h linux-2.4.22-ashuariadevel/drivers/block/DAC960.h
*** linux-2.4.22-ashuariadevel.backup/drivers/block/DAC960.h	2001-10-18 06:46:29.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/DAC960.h	2004-02-02 14:35:08.000000000 +0900
***************
*** 2473,2479 ****
      } V2;
    } FW;
    DiskPartition_T DiskPartitions[DAC960_MinorCount];
!   int PartitionSizes[DAC960_MinorCount];
    int BlockSizes[DAC960_MinorCount];
    int MaxSectorsPerRequest[DAC960_MinorCount];
    unsigned char ProgressBuffer[DAC960_ProgressBufferSize];
--- 2473,2479 ----
      } V2;
    } FW;
    DiskPartition_T DiskPartitions[DAC960_MinorCount];
!   sector_t PartitionSizes[DAC960_MinorCount];
    int BlockSizes[DAC960_MinorCount];
    int MaxSectorsPerRequest[DAC960_MinorCount];
    unsigned char ProgressBuffer[DAC960_ProgressBufferSize];
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/blkpg.c linux-2.4.22-ashuariadevel/drivers/block/blkpg.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/blkpg.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/blkpg.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 66,73 ****
   */
  int add_partition(kdev_t dev, struct blkpg_partition *p) {
  	struct gendisk *g;
! 	long long ppstart, pplength;
! 	long pstart, plength;
  	int i, drive, first_minor, end_minor, minor;
  
  	/* convert bytes to sectors, check for fit in a hd_struct */
--- 66,74 ----
   */
  int add_partition(kdev_t dev, struct blkpg_partition *p) {
  	struct gendisk *g;
! 	long long ppstart;
! 	long long pplength;
! 	sector_t pstart, plength;
  	int i, drive, first_minor, end_minor, minor;
  
  	/* convert bytes to sectors, check for fit in a hd_struct */
***************
*** 247,256 ****
  			if (g)
  				ullval = g->part[MINOR(dev)].nr_sects;
  
! 			if (cmd == BLKGETSIZE)
  				return put_user((unsigned long)ullval, (unsigned long *)arg);
! 			else
! 				return put_user(ullval << 9, (u64 *)arg);
  #if 0
  		case BLKRRPART: /* Re-read partition tables */
  			if (!capable(CAP_SYS_ADMIN)) 
--- 248,259 ----
  			if (g)
  				ullval = g->part[MINOR(dev)].nr_sects;
  
! 			if (cmd == BLKGETSIZE) {
! 				if ((unsigned long)ullval != ullval)
! 					return -EFBIG;
  				return put_user((unsigned long)ullval, (unsigned long *)arg);
! 			}
! 			return put_user(ullval << 9, (u64 *)arg);
  #if 0
  		case BLKRRPART: /* Re-read partition tables */
  			if (!capable(CAP_SYS_ADMIN)) 
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/cciss.c linux-2.4.22-ashuariadevel/drivers/block/cciss.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/cciss.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/cciss.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 505,511 ****
  			driver_geo.heads = 0xff;
  			driver_geo.sectors = 0x3f;
  			driver_geo.cylinders = 
! 				hba[ctlr]->drv[dsk].nr_blocks / (0xff*0x3f);
  		}
  		driver_geo.start=
  			hba[ctlr]->hd[MINOR(inode->i_rdev)].start_sect;
--- 505,511 ----
  			driver_geo.heads = 0xff;
  			driver_geo.sectors = 0x3f;
  			driver_geo.cylinders = 
! 				(int)hba[ctlr]->drv[dsk].nr_blocks / (0xff*0x3f);
  		}
  		driver_geo.start=
  			hba[ctlr]->hd[MINOR(inode->i_rdev)].start_sect;
***************
*** 525,531 ****
  			driver_geo.heads = 0xff;
  			driver_geo.sectors = 0x3f;
  			driver_geo.cylinders = 
! 				hba[ctlr]->drv[dsk].nr_blocks / (0xff*0x3f);
  		}
  		driver_geo.start= 
  		hba[ctlr]->hd[MINOR(inode->i_rdev)].start_sect;
--- 525,531 ----
  			driver_geo.heads = 0xff;
  			driver_geo.sectors = 0x3f;
  			driver_geo.cylinders = 
! 				(int)hba[ctlr]->drv[dsk].nr_blocks / (0xff*0x3f);
  		}
  		driver_geo.start= 
  		hba[ctlr]->hd[MINOR(inode->i_rdev)].start_sect;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/cciss.h linux-2.4.22-ashuariadevel/drivers/block/cciss.h
*** linux-2.4.22-ashuariadevel.backup/drivers/block/cciss.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/cciss.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 84,90 ****
  	struct gendisk   gendisk;
  	   // indexed by minor numbers
  	struct hd_struct hd[256];
! 	int              sizes[256];
  	int              blocksizes[256];
  	int              hardsizes[256];
  	int busy_configuring;
--- 84,90 ----
  	struct gendisk   gendisk;
  	   // indexed by minor numbers
  	struct hd_struct hd[256];
! 	sector_t         sizes[256];
  	int              blocksizes[256];
  	int              hardsizes[256];
  	int busy_configuring;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/cpqarray.h linux-2.4.22-ashuariadevel/drivers/block/cpqarray.h
*** linux-2.4.22-ashuariadevel.backup/drivers/block/cpqarray.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/cpqarray.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 123,129 ****
  	struct gendisk gendisk;
  	// Index by Minor Numbers
  	struct hd_struct	hd[256];
! 	int			sizes[256];
  	int			blocksizes[256];
  	int			hardsizes[256];
  };
--- 123,129 ----
  	struct gendisk gendisk;
  	// Index by Minor Numbers
  	struct hd_struct	hd[256];
! 	sector_t		sizes[256];
  	int			blocksizes[256];
  	int			hardsizes[256];
  };
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/floppy.c linux-2.4.22-ashuariadevel/drivers/block/floppy.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/floppy.c	2003-08-25 20:44:41.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/floppy.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 480,486 ****
   */
  static struct floppy_struct user_params[N_DRIVE];
  
! static int floppy_sizes[256];
  static int floppy_blocksizes[256];
  static int floppy_maxsectors[256];
  
--- 480,486 ----
   */
  static struct floppy_struct user_params[N_DRIVE];
  
! static sector_t floppy_sizes[256];
  static int floppy_blocksizes[256];
  static int floppy_maxsectors[256];
  
***************
*** 583,589 ****
  static struct floppy_struct *_floppy = floppy_type;
  static unsigned char current_drive;
  static long current_count_sectors;
! static unsigned char sector_t; /* sector in track */
  static unsigned char in_sector_offset;	/* offset within physical sector,
  					 * expressed in units of 512 bytes */
  
--- 583,589 ----
  static struct floppy_struct *_floppy = floppy_type;
  static unsigned char current_drive;
  static long current_count_sectors;
! static unsigned char sector; /* sector in track */
  static unsigned char in_sector_offset;	/* offset within physical sector,
  					 * expressed in units of 512 bytes */
  
***************
*** 2405,2411 ****
  		printk("rt=%d t=%d\n", R_TRACK, TRACK);
  		printk("heads=%d eoc=%d\n", heads, eoc);
  		printk("spt=%d st=%d ss=%d\n", SECT_PER_TRACK,
! 		       sector_t, ssize);
  		printk("in_sector_offset=%d\n", in_sector_offset);
  	}
  #endif
--- 2405,2411 ----
  		printk("rt=%d t=%d\n", R_TRACK, TRACK);
  		printk("heads=%d eoc=%d\n", heads, eoc);
  		printk("spt=%d st=%d ss=%d\n", SECT_PER_TRACK,
! 		       sector, ssize);
  		printk("in_sector_offset=%d\n", in_sector_offset);
  	}
  #endif
***************
*** 2452,2458 ****
  	} else if (CT(COMMAND) == FD_READ){
  		buffer_track = raw_cmd->track;
  		buffer_drive = current_drive;
! 		INFBOUND(buffer_max, nr_sectors + sector_t);
  	}
  	cont->redo();
  }
--- 2452,2458 ----
  	} else if (CT(COMMAND) == FD_READ){
  		buffer_track = raw_cmd->track;
  		buffer_drive = current_drive;
! 		INFBOUND(buffer_max, nr_sectors + sector);
  	}
  	cont->redo();
  }
***************
*** 2481,2493 ****
  /* Compute the maximal transfer size */
  static int transfer_size(int ssize, int max_sector, int max_size)
  {
! 	SUPBOUND(max_sector, sector_t + max_size);
  
  	/* alignment */
  	max_sector -= (max_sector % _floppy->sect) % ssize;
  
  	/* transfer size, beginning not aligned */
! 	current_count_sectors = max_sector - sector_t ;
  
  	return max_sector;
  }
--- 2481,2493 ----
  /* Compute the maximal transfer size */
  static int transfer_size(int ssize, int max_sector, int max_size)
  {
! 	SUPBOUND(max_sector, sector + max_size);
  
  	/* alignment */
  	max_sector -= (max_sector % _floppy->sect) % ssize;
  
  	/* transfer size, beginning not aligned */
! 	current_count_sectors = max_sector - sector ;
  
  	return max_sector;
  }
***************
*** 2507,2514 ****
  				   CURRENT->nr_sectors);
  
  	if (current_count_sectors <= 0 && CT(COMMAND) == FD_WRITE &&
! 	    buffer_max > sector_t + CURRENT->nr_sectors)
! 		current_count_sectors = minimum(buffer_max - sector_t,
  						CURRENT->nr_sectors);
  
  	remaining = current_count_sectors << 9;
--- 2507,2514 ----
  				   CURRENT->nr_sectors);
  
  	if (current_count_sectors <= 0 && CT(COMMAND) == FD_WRITE &&
! 	    buffer_max > sector + CURRENT->nr_sectors)
! 		current_count_sectors = minimum(buffer_max - sector,
  						CURRENT->nr_sectors);
  
  	remaining = current_count_sectors << 9;
***************
*** 2528,2534 ****
  
  	buffer_max = maximum(max_sector, buffer_max);
  
! 	dma_buffer = floppy_track_buffer + ((sector_t - buffer_min) << 9);
  
  	bh = CURRENT->bh;
  	size = CURRENT->current_nr_sectors << 9;
--- 2528,2534 ----
  
  	buffer_max = maximum(max_sector, buffer_max);
  
! 	dma_buffer = floppy_track_buffer + ((sector - buffer_min) << 9);
  
  	bh = CURRENT->bh;
  	size = CURRENT->current_nr_sectors << 9;
***************
*** 2542,2549 ****
  		    dma_buffer < floppy_track_buffer){
  			DPRINT("buffer overrun in copy buffer %d\n",
  				(int) ((floppy_track_buffer - dma_buffer) >>9));
! 			printk("sector_t=%d buffer_min=%d\n",
! 			       sector_t, buffer_min);
  			printk("current_count_sectors=%ld\n",
  			       current_count_sectors);
  			if (CT(COMMAND) == FD_READ)
--- 2542,2549 ----
  		    dma_buffer < floppy_track_buffer){
  			DPRINT("buffer overrun in copy buffer %d\n",
  				(int) ((floppy_track_buffer - dma_buffer) >>9));
! 			printk("sector=%d buffer_min=%d\n",
! 			       sector, buffer_min);
  			printk("current_count_sectors=%ld\n",
  			       current_count_sectors);
  			if (CT(COMMAND) == FD_READ)
***************
*** 2636,2642 ****
  
  static int make_raw_rw_request(void)
  {
! 	int aligned_sector_t;
  	int max_sector, max_size, tracksize, ssize;
  
  	if(max_buffer_sectors == 0) {
--- 2636,2642 ----
  
  static int make_raw_rw_request(void)
  {
! 	int aligned_sector;
  	int max_sector, max_size, tracksize, ssize;
  
  	if(max_buffer_sectors == 0) {
***************
*** 2663,2670 ****
  
  	max_sector = _floppy->sect * _floppy->head;
  
! 	TRACK = CURRENT->sector / max_sector;
! 	sector_t = CURRENT->sector % max_sector;
  	if (_floppy->track && TRACK >= _floppy->track) {
  		if (CURRENT->current_nr_sectors & 1) {
  			current_count_sectors = 1;
--- 2663,2670 ----
  
  	max_sector = _floppy->sect * _floppy->head;
  
! 	TRACK = (long)CURRENT->sector / max_sector;
! 	sector = (long)CURRENT->sector % max_sector;
  	if (_floppy->track && TRACK >= _floppy->track) {
  		if (CURRENT->current_nr_sectors & 1) {
  			current_count_sectors = 1;
***************
*** 2672,2688 ****
  		} else
  			return 0;
  	}
! 	HEAD = sector_t / _floppy->sect;
  
  	if (((_floppy->stretch & FD_SWAPSIDES) || TESTF(FD_NEED_TWADDLE)) &&
! 	    sector_t < _floppy->sect)
  		max_sector = _floppy->sect;
  
  	/* 2M disks have phantom sectors on the first track */
  	if ((_floppy->rate & FD_2M) && (!TRACK) && (!HEAD)){
  		max_sector = 2 * _floppy->sect / 3;
! 		if (sector_t >= max_sector){
! 			current_count_sectors = minimum(_floppy->sect - sector_t,
  							CURRENT->nr_sectors);
  			return 1;
  		}
--- 2672,2688 ----
  		} else
  			return 0;
  	}
! 	HEAD = sector / _floppy->sect;
  
  	if (((_floppy->stretch & FD_SWAPSIDES) || TESTF(FD_NEED_TWADDLE)) &&
! 	    sector < _floppy->sect)
  		max_sector = _floppy->sect;
  
  	/* 2M disks have phantom sectors on the first track */
  	if ((_floppy->rate & FD_2M) && (!TRACK) && (!HEAD)){
  		max_sector = 2 * _floppy->sect / 3;
! 		if (sector >= max_sector){
! 			current_count_sectors = minimum(_floppy->sect - sector,
  							CURRENT->nr_sectors);
  			return 1;
  		}
***************
*** 2704,2710 ****
  	GAP = _floppy->gap;
  	CODE2SIZE;
  	SECT_PER_TRACK = _floppy->sect << 2 >> SIZECODE;
! 	SECTOR = ((sector_t % _floppy->sect) << 2 >> SIZECODE) + 1;
  
  	/* tracksize describes the size which can be filled up with sectors
  	 * of size ssize.
--- 2704,2710 ----
  	GAP = _floppy->gap;
  	CODE2SIZE;
  	SECT_PER_TRACK = _floppy->sect << 2 >> SIZECODE;
! 	SECTOR = ((sector % _floppy->sect) << 2 >> SIZECODE) + 1;
  
  	/* tracksize describes the size which can be filled up with sectors
  	 * of size ssize.
***************
*** 2712,2722 ****
  	tracksize = _floppy->sect - _floppy->sect % ssize;
  	if (tracksize < _floppy->sect){
  		SECT_PER_TRACK ++;
! 		if (tracksize <= sector_t % _floppy->sect)
  			SECTOR--;
  
  		/* if we are beyond tracksize, fill up using smaller sectors */
! 		while (tracksize <= sector_t % _floppy->sect){
  			while(tracksize + ssize > _floppy->sect){
  				SIZECODE--;
  				ssize >>= 1;
--- 2712,2722 ----
  	tracksize = _floppy->sect - _floppy->sect % ssize;
  	if (tracksize < _floppy->sect){
  		SECT_PER_TRACK ++;
! 		if (tracksize <= sector % _floppy->sect)
  			SECTOR--;
  
  		/* if we are beyond tracksize, fill up using smaller sectors */
! 		while (tracksize <= sector % _floppy->sect){
  			while(tracksize + ssize > _floppy->sect){
  				SIZECODE--;
  				ssize >>= 1;
***************
*** 2732,2743 ****
  		max_sector = _floppy->sect;
  	}
  
! 	in_sector_offset = (sector_t % _floppy->sect) % ssize;
! 	aligned_sector_t = sector_t - in_sector_offset;
  	max_size = CURRENT->nr_sectors;
  	if ((raw_cmd->track == buffer_track) && 
  	    (current_drive == buffer_drive) &&
! 	    (sector_t >= buffer_min) && (sector_t < buffer_max)) {
  		/* data already in track buffer */
  		if (CT(COMMAND) == FD_READ) {
  			copy_buffer(1, max_sector, buffer_max);
--- 2732,2743 ----
  		max_sector = _floppy->sect;
  	}
  
! 	in_sector_offset = (sector % _floppy->sect) % ssize;
! 	aligned_sector = sector - in_sector_offset;
  	max_size = CURRENT->nr_sectors;
  	if ((raw_cmd->track == buffer_track) && 
  	    (current_drive == buffer_drive) &&
! 	    (sector >= buffer_min) && (sector < buffer_max)) {
  		/* data already in track buffer */
  		if (CT(COMMAND) == FD_READ) {
  			copy_buffer(1, max_sector, buffer_max);
***************
*** 2745,2752 ****
  		}
  	} else if (in_sector_offset || CURRENT->nr_sectors < ssize){
  		if (CT(COMMAND) == FD_WRITE){
! 			if (sector_t + CURRENT->nr_sectors > ssize &&
! 			    sector_t + CURRENT->nr_sectors < ssize + ssize)
  				max_size = ssize + ssize;
  			else
  				max_size = ssize;
--- 2745,2752 ----
  		}
  	} else if (in_sector_offset || CURRENT->nr_sectors < ssize){
  		if (CT(COMMAND) == FD_WRITE){
! 			if (sector + CURRENT->nr_sectors > ssize &&
! 			    sector + CURRENT->nr_sectors < ssize + ssize)
  				max_size = ssize + ssize;
  			else
  				max_size = ssize;
***************
*** 2759,2765 ****
  		int direct, indirect;
  
  		indirect= transfer_size(ssize,max_sector,max_buffer_sectors*2) -
! 			sector_t;
  
  		/*
  		 * Do NOT use minimum() here---MAX_DMA_ADDRESS is 64 bits wide
--- 2759,2765 ----
  		int direct, indirect;
  
  		indirect= transfer_size(ssize,max_sector,max_buffer_sectors*2) -
! 			sector;
  
  		/*
  		 * Do NOT use minimum() here---MAX_DMA_ADDRESS is 64 bits wide
***************
*** 2774,2780 ****
  		if (CROSS_64KB(CURRENT->buffer, max_size << 9))
  			max_size = (K_64 - 
  				    ((unsigned long)CURRENT->buffer) % K_64)>>9;
! 		direct = transfer_size(ssize,max_sector,max_size) - sector_t;
  		/*
  		 * We try to read tracks, but if we get too many errors, we
  		 * go back to reading just one sector at a time.
--- 2774,2780 ----
  		if (CROSS_64KB(CURRENT->buffer, max_size << 9))
  			max_size = (K_64 - 
  				    ((unsigned long)CURRENT->buffer) % K_64)>>9;
! 		direct = transfer_size(ssize,max_sector,max_size) - sector;
  		/*
  		 * We try to read tracks, but if we get too many errors, we
  		 * go back to reading just one sector at a time.
***************
*** 2793,2800 ****
  			raw_cmd->length = current_count_sectors << 9;
  			if (raw_cmd->length == 0){
  				DPRINT("zero dma transfer attempted from make_raw_request\n");
! 				DPRINT("indirect=%d direct=%d sector_t=%d",
! 					indirect, direct, sector_t);
  				return 0;
  			}
  /*			check_dma_crossing(raw_cmd->kernel_data, 
--- 2793,2800 ----
  			raw_cmd->length = current_count_sectors << 9;
  			if (raw_cmd->length == 0){
  				DPRINT("zero dma transfer attempted from make_raw_request\n");
! 				DPRINT("indirect=%d direct=%d sector=%d",
! 					indirect, direct, sector);
  				return 0;
  			}
  /*			check_dma_crossing(raw_cmd->kernel_data, 
***************
*** 2812,2830 ****
  	/* claim buffer track if needed */
  	if (buffer_track != raw_cmd->track ||  /* bad track */
  	    buffer_drive !=current_drive || /* bad drive */
! 	    sector_t > buffer_max ||
! 	    sector_t < buffer_min ||
  	    ((CT(COMMAND) == FD_READ ||
  	      (!in_sector_offset && CURRENT->nr_sectors >= ssize))&&
  	     max_sector > 2 * max_buffer_sectors + buffer_min &&
! 	     max_size + sector_t > 2 * max_buffer_sectors + buffer_min)
  	    /* not enough space */){
  		buffer_track = -1;
  		buffer_drive = current_drive;
! 		buffer_max = buffer_min = aligned_sector_t;
  	}
  	raw_cmd->kernel_data = floppy_track_buffer + 
! 		((aligned_sector_t-buffer_min)<<9);
  
  	if (CT(COMMAND) == FD_WRITE){
  		/* copy write buffer to track buffer.
--- 2812,2830 ----
  	/* claim buffer track if needed */
  	if (buffer_track != raw_cmd->track ||  /* bad track */
  	    buffer_drive !=current_drive || /* bad drive */
! 	    sector > buffer_max ||
! 	    sector < buffer_min ||
  	    ((CT(COMMAND) == FD_READ ||
  	      (!in_sector_offset && CURRENT->nr_sectors >= ssize))&&
  	     max_sector > 2 * max_buffer_sectors + buffer_min &&
! 	     max_size + sector > 2 * max_buffer_sectors + buffer_min)
  	    /* not enough space */){
  		buffer_track = -1;
  		buffer_drive = current_drive;
! 		buffer_max = buffer_min = aligned_sector;
  	}
  	raw_cmd->kernel_data = floppy_track_buffer + 
! 		((aligned_sector-buffer_min)<<9);
  
  	if (CT(COMMAND) == FD_WRITE){
  		/* copy write buffer to track buffer.
***************
*** 2840,2846 ****
  		copy_buffer(ssize, max_sector, 2*max_buffer_sectors+buffer_min);
  	} else
  		transfer_size(ssize, max_sector,
! 			      2*max_buffer_sectors+buffer_min-aligned_sector_t);
  
  	/* round up current_count_sectors to get dma xfer size */
  	raw_cmd->length = in_sector_offset+current_count_sectors;
--- 2840,2846 ----
  		copy_buffer(ssize, max_sector, 2*max_buffer_sectors+buffer_min);
  	} else
  		transfer_size(ssize, max_sector,
! 			      2*max_buffer_sectors+buffer_min-aligned_sector);
  
  	/* round up current_count_sectors to get dma xfer size */
  	raw_cmd->length = in_sector_offset+current_count_sectors;
***************
*** 2852,2859 ****
  	if ((raw_cmd->length < current_count_sectors << 9) ||
  	    (raw_cmd->kernel_data != CURRENT->buffer &&
  	     CT(COMMAND) == FD_WRITE &&
! 	     (aligned_sector_t + (raw_cmd->length >> 9) > buffer_max ||
! 	      aligned_sector_t < buffer_min)) ||
  	    raw_cmd->length % (128 << SIZECODE) ||
  	    raw_cmd->length <= 0 || current_count_sectors <= 0){
  		DPRINT("fractionary current count b=%lx s=%lx\n",
--- 2852,2859 ----
  	if ((raw_cmd->length < current_count_sectors << 9) ||
  	    (raw_cmd->kernel_data != CURRENT->buffer &&
  	     CT(COMMAND) == FD_WRITE &&
! 	     (aligned_sector + (raw_cmd->length >> 9) > buffer_max ||
! 	      aligned_sector < buffer_min)) ||
  	    raw_cmd->length % (128 << SIZECODE) ||
  	    raw_cmd->length <= 0 || current_count_sectors <= 0){
  		DPRINT("fractionary current count b=%lx s=%lx\n",
***************
*** 2864,2870 ****
  				       floppy_track_buffer) >> 9),
  			       current_count_sectors);
  		printk("st=%d ast=%d mse=%d msi=%d\n",
! 		       sector_t, aligned_sector_t, max_sector, max_size);
  		printk("ssize=%x SIZECODE=%d\n", ssize, SIZECODE);
  		printk("command=%x SECTOR=%d HEAD=%d, TRACK=%d\n",
  		       COMMAND, SECTOR, HEAD, TRACK);
--- 2864,2870 ----
  				       floppy_track_buffer) >> 9),
  			       current_count_sectors);
  		printk("st=%d ast=%d mse=%d msi=%d\n",
! 		       sector, aligned_sector, max_sector, max_size);
  		printk("ssize=%x SIZECODE=%d\n", ssize, SIZECODE);
  		printk("command=%x SECTOR=%d HEAD=%d, TRACK=%d\n",
  		       COMMAND, SECTOR, HEAD, TRACK);
***************
*** 2882,2889 ****
  		    raw_cmd->kernel_data + raw_cmd->length >
  		    floppy_track_buffer + (max_buffer_sectors  << 10)){
  			DPRINT("buffer overrun in schedule dma\n");
! 			printk("sector_t=%d buffer_min=%d current_count=%ld\n",
! 			       sector_t, buffer_min,
  			       raw_cmd->length >> 9);
  			printk("current_count_sectors=%ld\n",
  			       current_count_sectors);
--- 2882,2889 ----
  		    raw_cmd->kernel_data + raw_cmd->length >
  		    floppy_track_buffer + (max_buffer_sectors  << 10)){
  			DPRINT("buffer overrun in schedule dma\n");
! 			printk("sector=%d buffer_min=%d current_count=%ld\n",
! 			       sector, buffer_min,
  			       raw_cmd->length >> 9);
  			printk("current_count_sectors=%ld\n",
  			       current_count_sectors);
***************
*** 3005,3011 ****
  
  	if (usage_count == 0) {
  		printk("warning: usage count=0, CURRENT=%p exiting\n", CURRENT);
! 		printk("sect=%ld cmd=%d\n", CURRENT->sector, CURRENT->cmd);
  		return;
  	}
  	if (test_bit(0, &fdc_busy)) {
--- 3005,3011 ----
  
  	if (usage_count == 0) {
  		printk("warning: usage count=0, CURRENT=%p exiting\n", CURRENT);
! 		printk("sect=%llu cmd=%d\n", (unsigned long long)CURRENT->sector, CURRENT->cmd);
  		return;
  	}
  	if (test_bit(0, &fdc_busy)) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/genhd.c linux-2.4.22-ashuariadevel/drivers/block/genhd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/genhd.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/genhd.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 198,206 ****
  			struct hd_struct *hd = &gp->part[n];
  
  			disk_round_stats(hd);
! 			seq_printf(s, "%4d  %4d %10d %s "
  				      "%d %d %d %d %d %d %d %d %d %d %d\n",
! 				      gp->major, n, gp->sizes[n],
  				      disk_name(gp, n, buf),
  				      hd->rd_ios, hd->rd_merges,
  #define MSEC(x) ((x) * 1000 / HZ)
--- 198,206 ----
  			struct hd_struct *hd = &gp->part[n];
  
  			disk_round_stats(hd);
! 			seq_printf(s, "%4d  %4d %10llu %s "
  				      "%d %d %d %d %d %d %d %d %d %d %d\n",
! 				      gp->major, n, (unsigned long long)gp->sizes[n],
  				      disk_name(gp, n, buf),
  				      hd->rd_ios, hd->rd_merges,
  #define MSEC(x) ((x) * 1000 / HZ)
***************
*** 210,217 ****
  				      hd->ios_in_flight, MSEC(hd->io_ticks),
  				      MSEC(hd->aveq));
  #else
! 			seq_printf(s, "%4d  %4d %10d %s\n",
! 				   gp->major, n, gp->sizes[n],
  				   disk_name(gp, n, buf));
  #endif /* CONFIG_BLK_STATS */
  		}
--- 210,217 ----
  				      hd->ios_in_flight, MSEC(hd->io_ticks),
  				      MSEC(hd->aveq));
  #else
! 			seq_printf(s, "%4d  %4d %10llu %s\n",
! 				   gp->major, n, (unsigned long long)gp->sizes[n],
  				   disk_name(gp, n, buf));
  #endif /* CONFIG_BLK_STATS */
  		}
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/ll_rw_blk.c linux-2.4.22-ashuariadevel/drivers/block/ll_rw_blk.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/ll_rw_blk.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/ll_rw_blk.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 83,92 ****
   *
   * if (!blk_size[MAJOR]) then no minor size checking is done.
   */
! int * blk_size[MAX_BLKDEV];
  
  /*
!  * blksize_size contains the size of all block-devices:
   *
   * blksize_size[MAJOR][MINOR]
   *
--- 83,92 ----
   *
   * if (!blk_size[MAJOR]) then no minor size checking is done.
   */
! sector_t * blk_size[MAX_BLKDEV];
  
  /*
!  * blksize_size contains the block size of all block-devices:
   *
   * blksize_size[MAJOR][MINOR]
   *
***************
*** 990,996 ****
  static int __make_request(request_queue_t * q, int rw,
  				  struct buffer_head * bh)
  {
! 	unsigned int sector, count, sync;
  	int max_segments = MAX_SEGMENTS;
  	struct request * req, *freereq = NULL;
  	int rw_ahead, max_sectors, el_ret;
--- 990,997 ----
  static int __make_request(request_queue_t * q, int rw,
  				  struct buffer_head * bh)
  {
! 	sector_t sector;
! 	int count, sync;
  	int max_segments = MAX_SEGMENTS;
  	struct request * req, *freereq = NULL;
  	int rw_ahead, max_sectors, el_ret;
***************
*** 1178,1184 ****
  }
  
  /**
!  * generic_make_request: hand a buffer head to it's device driver for I/O
   * @rw:  READ, WRITE, or READA - what sort of I/O is desired.
   * @bh:  The buffer head describing the location in memory and on the device.
   *
--- 1179,1185 ----
  }
  
  /**
!  * generic_make_request: hand a buffer head to its device driver for I/O
   * @rw:  READ, WRITE, or READA - what sort of I/O is desired.
   * @bh:  The buffer head describing the location in memory and on the device.
   *
***************
*** 1214,1220 ****
  void generic_make_request (int rw, struct buffer_head * bh)
  {
  	int major = MAJOR(bh->b_rdev);
! 	int minorsize = 0;
  	request_queue_t *q;
  
  	if (!bh->b_end_io)
--- 1215,1221 ----
  void generic_make_request (int rw, struct buffer_head * bh)
  {
  	int major = MAJOR(bh->b_rdev);
! 	sector_t minorsize = 0;
  	request_queue_t *q;
  
  	if (!bh->b_end_io)
***************
*** 1224,1231 ****
  	if (blk_size[major])
  		minorsize = blk_size[major][MINOR(bh->b_rdev)];
  	if (minorsize) {
! 		unsigned long maxsector = (minorsize << 1) + 1;
! 		unsigned long sector = bh->b_rsector;
  		unsigned int count = bh->b_size >> 9;
  
  		if (maxsector < count || maxsector - count < sector) {
--- 1225,1232 ----
  	if (blk_size[major])
  		minorsize = blk_size[major][MINOR(bh->b_rdev)];
  	if (minorsize) {
! 		sector_t maxsector = (minorsize << 1) + 1;
! 		sector_t sector = bh->b_rsector;
  		unsigned int count = bh->b_size >> 9;
  
  		if (maxsector < count || maxsector - count < sector) {
***************
*** 1237,1245 ****
  			   when mounting a device. */
  			printk(KERN_INFO
  			       "attempt to access beyond end of device\n");
! 			printk(KERN_INFO "%s: rw=%d, want=%ld, limit=%d\n",
  			       kdevname(bh->b_rdev), rw,
! 			       (sector + count)>>1, minorsize);
  
  			bh->b_end_io(bh, 0);
  			return;
--- 1238,1247 ----
  			   when mounting a device. */
  			printk(KERN_INFO
  			       "attempt to access beyond end of device\n");
! 			printk(KERN_INFO "%s: rw=%d, want=%llu, limit=%llu\n",
  			       kdevname(bh->b_rdev), rw,
! 			       (unsigned long long)((sector + count)>>1), 
! 			       (unsigned long long)minorsize);
  
  			bh->b_end_io(bh, 0);
  			return;
***************
*** 1259,1266 ****
  		if (!q) {
  			printk(KERN_ERR
  			       "generic_make_request: Trying to access "
! 			       "nonexistent block-device %s (%ld)\n",
! 			       kdevname(bh->b_rdev), bh->b_rsector);
  			buffer_IO_error(bh);
  			break;
  		}
--- 1261,1268 ----
  		if (!q) {
  			printk(KERN_ERR
  			       "generic_make_request: Trying to access "
! 			       "nonexistent block-device %s (%llu)\n",
! 			       kdevname(bh->b_rdev), (unsigned long long)bh->b_rsector);
  			buffer_IO_error(bh);
  			break;
  		}
***************
*** 1461,1468 ****
  
  	req->errors = 0;
  	if (!uptodate)
! 		printk("end_request: I/O error, dev %s (%s), sector %lu\n",
! 			kdevname(req->rq_dev), name, req->sector);
  
  	if ((bh = req->bh) != NULL) {
  		nsect = bh->b_size >> 9;
--- 1463,1470 ----
  
  	req->errors = 0;
  	if (!uptodate)
! 		printk("end_request: I/O error, dev %s (%s), sector %llu\n",
! 			kdevname(req->rq_dev), name, (unsigned long long)req->sector);
  
  	if ((bh = req->bh) != NULL) {
  		nsect = bh->b_size >> 9;
